#include "dcrpgcamera.h"
#include "dcrpggame.h"
#include "dcrpgsprite.h"

extern dcrpg::DCRPG *dcrpgGame;

namespace dcrpg	{	
	DCRPGCamera::DCRPGCamera(int x, int y, DCRPGSprite *p)	{
		xpos=x;
		ypos=y;
		player=p;
	}
	
	DCRPGCamera::~DCRPGCamera()	{
	}

	void DCRPGCamera::setPlayer(DCRPGSprite *p)	{
		player = p;
	}

	void DCRPGCamera::setPos(int x, int y)	{
		xpos = x; 
		ypos = y;   
	}

	void DCRPGCamera::setXPos(int x)	{
		xpos = x;
	}

	void DCRPGCamera::setYPos(int y)	{
		ypos = y;
	}

	int DCRPGCamera::getXPos()	{
		return xpos;
	}

	int DCRPGCamera::getYPos()	{
		return ypos;
	}

	void DCRPGCamera::update()	{
		ccLJMMap *map=dcrpgGame->getMap();

		if (player->getState() == DCRPGSprite::STATE_WALKING)	{
			if(player->getRealXPos() < 320 - (player->getWidth() / 2) )	{
				setXPos(0);
			}
			else if(player->getRealXPos() > (map->getWidth() * 32) - 320 - (player->getWidth() / 2))	{
				setXPos((map->getWidth() * 32) - 640);
			}
			else	{
				setXPos(player->getRealXPos() - 320 + (player->getWidth() / 2));
			}
	
			if(player->getRealYPos() < 240 - (player->getHeight() / 2))	{
				setYPos(0);
			}
			else if(player->getRealYPos() > (map->getHeight() * 32) - 240 - (player->getHeight() / 2))	{
				setYPos((map->getHeight() * 32) - 480);
			}
			else	{
				setYPos(player->getRealYPos() - 240 + (player->getHeight() / 2));
			}
				
			// place the players.
			player->setPos(player->getRealXPos() - xpos, player->getRealYPos() - ypos, 5);
		    
			// Set map offsets...
			map->setOffsets(xpos / 32, ypos / 32, xpos % 32, ypos % 32);
		}
	}			
}
