
#include "dcrpggame.h"
#include <ccscenemgr.h>
#include <kos.h>

using namespace dcrpg;
using namespace crabclaw;

extern DCRPG *dcrpgGame;

static void __tempSetUpSprite()	{
	DCRPGSprite *sp1 = new DCRPGSprite(ccTexture::createFromPNG("/cd/thief.png"), 0.125, 0.125, ccScreen::LIST_TRANSLUCENT);
	ccSpriteAnim *left, *right, *up, *down;
	ccSpriteAnim *runleft, *runright, *runup, *rundown; 
	ccSpriteAnim *attackdown, *attackup, *attackleft, *attackright;

	sp1->setDimensions(64, 64);
	
	down = new ccSpriteAnim(80, 1);
	down->addFrame(0, 0);
	down->addFrame(1, 0);
	down->addFrame(2, 0);
	down->addFrame(3, 0);
	down->addFrame(4, 0);

	rundown = new ccSpriteAnim(80, 1);
	rundown->addFrame(0, 0);
	rundown->addFrame(1, 0);
	rundown->addFrame(2, 0);
	rundown->addFrame(3, 0);
	rundown->addFrame(4, 0);

	up = new ccSpriteAnim(80, 1);
	up->addFrame(0, 1);
	up->addFrame(1, 1);
	up->addFrame(2, 1);
	up->addFrame(3, 1);
	up->addFrame(4, 1);

	runup = new ccSpriteAnim(80, 1);
	runup->addFrame(0, 1);
	runup->addFrame(1, 1);
	runup->addFrame(2, 1);
	runup->addFrame(3, 1);
	runup->addFrame(4, 1);

	left = new ccSpriteAnim(80, 1);
	left->addFrame(0, 3);
	left->addFrame(1, 3);
	left->addFrame(2, 3);
	left->addFrame(3, 3);
	left->addFrame(4, 3);

	runleft = new ccSpriteAnim(40, 1);
	runleft->addFrame(0, 3);
	runleft->addFrame(1, 3);
	runleft->addFrame(2, 3);
	runleft->addFrame(3, 3);
	runleft->addFrame(4, 3);

	right = new ccSpriteAnim(80, 1);
	right->addFrame(0, 2);
	right->addFrame(1, 2);
	right->addFrame(2, 2);
	right->addFrame(3, 2);
	right->addFrame(4, 2);

	runright = new ccSpriteAnim(40, 0);
	runright->addFrame(0, 2);
	runright->addFrame(1, 2);
	runright->addFrame(2, 2);
	runright->addFrame(3, 2);
	runright->addFrame(4, 2);

	attackdown = new ccSpriteAnim(80, 0);
	attackdown->addFrame(4, 4);
	attackdown->addFrame(4, 5);

	attackup = new ccSpriteAnim(80, 1);
	attackup->addFrame(0, 1);
	attackup->addFrame(1, 1);
	attackup->addFrame(2, 1);
	attackup->addFrame(3, 1);
	attackup->addFrame(4, 1);

	attackleft = new ccSpriteAnim(80, 0);
	attackleft->addFrame(2, 4);
	attackleft->addFrame(3, 4);
	
	attackright = new ccSpriteAnim(80, 0);
	attackright->addFrame(0, 4);
	attackright->addFrame(1, 4);
	
	sp1->setAnim(right);    
	sp1->setPos(100, 200, 7);
	sp1->setRealPos(100, 200);   
	sp1->setDirection(DCRPGSprite::FACING_RIGHT);
	sp1->setState(DCRPGSprite::STATE_STANDING);
	sp1->setAnims(left, right, up, down, runleft, runright, runup, rundown, 
	              attackleft, attackright, attackup, attackdown);
	
	dcrpgGame->setPlayer(new DCRPGPlayer(25, sp1, dcrpgGame->getFont()));
}

static void __tempSetupEnemy()	{
	DCRPGSprite *sp1 = new DCRPGSprite(ccTexture::createFromPNG("/cd/enemy.png"), 0.25f, 0.125, ccScreen::LIST_TRANSLUCENT);
	ccSpriteAnim *left, *right, *up, *down;
	ccSpriteAnim *runleft, *runright, *runup, *rundown; 
	ccSpriteAnim *attackdown, *attackup, *attackleft, *attackright;
	
	sp1->setDimensions(64, 64);
	
	down = new ccSpriteAnim(80, 0);
	down->addFrame(0, 0);

	rundown = new ccSpriteAnim(80, 0);
	rundown->addFrame(0, 0);

	up = new ccSpriteAnim(80, 0);
	up->addFrame(2, 0);

	runup = new ccSpriteAnim(80, 0);
	runup->addFrame(2, 0);
	
	left = new ccSpriteAnim(80, 0);
	left->addFrame(1, 0);

	runleft = new ccSpriteAnim(80, 0);
	runleft->addFrame(1, 0);

	right = new ccSpriteAnim(80, 0);
	right->addFrame(3, 0);

	runright = new ccSpriteAnim(80, 0);
	runright->addFrame(3, 0);

	attackdown = new ccSpriteAnim(80, 0);
	attackdown->addFrame(0, 1);
	attackdown->addFrame(0, 2);
	attackdown->addFrame(0, 3);
	attackdown->addFrame(0, 4);

	attackup = new ccSpriteAnim(80, 0);
	attackup->addFrame(2, 1);
	attackup->addFrame(2, 2);
	attackup->addFrame(2, 3);
	attackup->addFrame(2, 4);

	attackleft = new ccSpriteAnim( 80, 0);
	attackleft->addFrame(1, 1);
	attackleft->addFrame(1, 2);
	attackleft->addFrame(1, 3);
	attackleft->addFrame(1, 4);

	attackright = new ccSpriteAnim(80, 0);
	attackright->addFrame(3, 1);
	attackright->addFrame(3, 2);
	attackright->addFrame(3, 3);
	attackright->addFrame(3, 4);

	sp1->setAnim(right );    
	sp1->setPos(200, 200, 5);
	sp1->setRealPos(200, 200);   
	sp1->setDirection(DCRPGSprite::FACING_RIGHT);
	sp1->setState(DCRPGSprite::STATE_STANDING);
	sp1->setAnims(left, right, up, down, runleft, runright, runup, rundown, 
	              attackleft, attackright, attackup, attackdown);
	sp1->setAttacking(false);

	DCRPGSprite *sprites[10];
	for(int k = 0; k < 10; k++)	{
		sprites[k] = new DCRPGSprite(*sp1);
	}

	DCRPGEnemy *enem;

	for(int i = 0; i < 10; i++)	{
		sprites[i]->setRealPos(100 * i + 20, 100 * i + 20);  
		enem = new DCRPGEnemy(25, sprites[i], dcrpgGame->getFont(), dcrpgGame);
		dcrpgGame->addEnemy(enem);
	}  
}
	

static void __tempLoadMap()	{
	dcrpgGame->setMap(new ccLJMMap("/cd/test_ljm.gz", 2));
}

static void sm_callback(ccSceneManager *sm)	{
	ccController *c1 = dcrpgGame->getController();
	DCRPGSprite *sp1 = dcrpgGame->getSprite();
	DCRPGPlayer *p1 = dcrpgGame->getPlayer();
	ccLJMMap *map = dcrpgGame->getMap();
	DCRPGCamera *camera = dcrpgGame->getCamera();
	DCRPGEnemy *enemy;
	int xpos, ypos;
	int walk_speed = 2;
	
	c1->poll();

	xpos = sp1->getRealXPos();
	ypos = sp1->getRealYPos();

	// Player Attacking()?
	if (c1->isPressed(2)) {
		if (!sp1->isAttacking()) {
			sp1->setAttacking(true);
			sp1->setDirection();
			enemy = dcrpgGame->getEnemyAt(sp1->getRealXPos(), sp1->getRealYPos(), sp1->getDirection());
			if(enemy != NULL)	{
				if(p1->getTimer() + 200 < ccTimer::getMilliseconds())	{
					enemy->beAttacked(10);
					p1->updateTimer();
				}
			}
		}
	}
    else
		sp1->setAttacking(false);
        
	// Player Running()?
	if (c1->isPressed(1)) {
		walk_speed += 2;
		if (!sp1->isRunning()) {
			sp1->setRunning(true);
			sp1->setDirection();
		}         
	}
	else {
		if (sp1->isRunning()) {
			sp1->setRunning(false);
			sp1->setDirection();
		}
	}

    // X axis movement
	if (c1->isPressed(7))	{
		if (xpos+walk_speed > ((map->getWidth() * 32) - sp1->getWidth()))
			xpos = (map->getWidth() * 32) - sp1->getWidth();
		else
			xpos += walk_speed;

		sp1->setState(DCRPGSprite::STATE_WALKING);
		if (!c1->isPressed(4) && !c1->isPressed(5))
			if (sp1->getDirection() != DCRPGSprite::FACING_RIGHT)
				sp1->setDirection(DCRPGSprite::FACING_RIGHT);
	}
	else if (c1->isPressed(6))	{
		if (xpos-walk_speed < 0)
			xpos = 0;
		else
			xpos -= walk_speed;
	
		sp1->setState(DCRPGSprite::STATE_WALKING);
		if (!c1->isPressed(4) && !c1->isPressed(5))
			if (sp1->getDirection() != DCRPGSprite::FACING_LEFT)
				sp1->setDirection(DCRPGSprite::FACING_LEFT);
	}

	// Y axis movement
	if (c1->isPressed(5))	{
		if (ypos + walk_speed > ((sp1->getHeight() * 32) - sp1->getHeight()))
			ypos = (map->getHeight() * 32) - sp1->getHeight();
		else
			ypos += walk_speed;

		sp1->setState(DCRPGSprite::STATE_WALKING);
		if (!c1->isPressed(6) && !c1->isPressed(7))
			if (sp1->getDirection() != DCRPGSprite::FACING_DOWN)
				sp1->setDirection(DCRPGSprite::FACING_DOWN);
	}
	else if (c1->isPressed(4))	{
		if (ypos - walk_speed < 0)
			ypos = 0;
		else
			ypos -= walk_speed;

		sp1->setState(DCRPGSprite::STATE_WALKING);
		if (!c1->isPressed(6) && !c1->isPressed(7))
			if (sp1->getDirection() != DCRPGSprite::FACING_UP)
				sp1->setDirection(DCRPGSprite::FACING_UP);
	}   

   	// Not moving?
	if (!c1->isPressed(4) && !c1->isPressed(5) && !c1->isPressed(6) && !c1->isPressed(7))	{
		sp1->setState(DCRPGSprite::STATE_STANDING);

		if (!sp1->isAttacking())    
			sp1->setDirection();   
	}
	else	{
		if(p1->getHP() > 0)	{
			if(map->getBlock((xpos + 32) / 32, (ypos + 64) / 32)->user4 != 1)	{
				sp1->setRealPos(xpos, ypos);
			}
		}
		else	{
			sp1->setRealPos(xpos, ypos);
		}
	}
	
#ifdef DEBUG
	if(c1->isPressed(9))	{
		vid_screen_shot("/pc/dcrpg.raw");
	}
#endif

	camera->update();
	map->incrementAnims();
}

namespace dcrpg	{
	void DCRPG::newGame()	{
		__tempSetUpSprite();
		__tempLoadMap();
		__tempSetupEnemy();
		player->updateTimer();
		camera = new DCRPGCamera(0, 0, getSprite());
		buttons = new ccSprite(ccTexture::createFromPNG("/cd/buttons.png"), 1.0f, 1.0f, ccScreen::LIST_TRANSLUCENT);
		buttons->setDimensions(128, 128);
		buttons->setPos(480, 300, 35);
		buttons->setDisplayed(0, 0);
		mainLoop();
	}
	
	void DCRPG::mainLoop()	{
		ccSceneManager *scm = new ccSceneManager(sm_callback, scr);
		
		curmap->setOffsets(0, 0);
		
		scm->add(curmap);
		scm->add(player);
		scm->add(buttons);
		for(int i = 0; i < 10; i++)	{
			scm->add(enemies[i]);
		}
		
		scm->run();
	}
	
	DCRPGEnemy *DCRPG::getEnemyAt(int x, int y, int d)	{
		int i, xr1, xr2, yr1, yr2;
		
		switch(d)	{
			case DCRPGSprite::FACING_DOWN:
				xr1 = -72;
				xr2 = 72;
				yr1 = -72;
				yr2 = 0;
				break;
			case DCRPGSprite::FACING_UP:
				xr1 = -72;
				xr2 = 72;
				yr1 = 0;
				yr2 = 72;
				break;
			case DCRPGSprite::FACING_LEFT:
				xr1 = 0;
				xr2 = 72;
				yr1 = -72;
				yr2 = 72;
				break;
			case DCRPGSprite::FACING_RIGHT:
				xr1 = -72;
				xr2 = 0;
				yr1 = -72;
				yr2 = 72;
				break;
			default:
				xr1 = yr1 = xr2 = yr2 = 0;
				break;
		}
		
		for(int i = 0; i < enemies.size(); i++)	{
			if(x - enemies[i]->getSprite()->getRealXPos() >= xr1 && x - enemies[i]->getSprite()->getRealXPos() <= xr2 &&
			   y - enemies[i]->getSprite()->getRealYPos() >= yr1 && y - enemies[i]->getSprite()->getRealYPos() <= yr2 &&
			   enemies[i]->getHP() > 0)	{
				return enemies[i];
			}
		}
		
		return NULL;
	}				
}
