
#include "dcrpgplayer.h"
#include "dcrpggame.h"

namespace dcrpg	{
	void DCRPGEnemy::move()	{
		DCRPGPlayer *player = game->getPlayer();
		DCRPGCamera *camera = game->getCamera();
		bool x = false, y = false;
		int mx, my, px, py;
		
		mx = sprite->getRealXPos();
		my = sprite->getRealYPos();
		px = player->getSprite()->getRealXPos();
		py = player->getSprite()->getRealYPos();
		
		if(mx - px < 200 && mx - px	> -200 && my - py < 200 && my - py > -200 && player->getHP() > 0)	{
			if(mx < px - 24)	{
				sprite->setRealXPos(mx + 1);
				x = true;
				sprite->setDirection(DCRPGSprite::FACING_RIGHT);
				sprite->setState(DCRPGSprite::STATE_WALKING);
			}
			else if(mx > px + 24)	{
				sprite->setRealXPos(mx - 1);
				x = true;
				sprite->setDirection(DCRPGSprite::FACING_LEFT);
				sprite->setState(DCRPGSprite::STATE_WALKING);
			}
			
			if(my < py - 24)	{
				sprite->setRealYPos(my + 1);
				y = true;
				if(!x)	{
					sprite->setDirection(DCRPGSprite::FACING_DOWN);
					sprite->setState(DCRPGSprite::STATE_WALKING);
				}
			}
			else if(my > py + 24)	{
				sprite->setRealYPos(my - 1);
				y = true;
				if(!x)	{
					sprite->setDirection(DCRPGSprite::FACING_UP);
					sprite->setState(DCRPGSprite::STATE_WALKING);
				}
			}
			
			if(x || y)	{
				sprite->setAttacking(false);
			}		
			else	{
				if(!sprite->isAttacking())	{
					sprite->setState(DCRPGSprite::STATE_STANDING);
					if(mx < px)	{
						sprite->setAttacking(true);
						sprite->setDirection();
					}
					else if(mx > px)	{
						sprite->setAttacking(true);
						sprite->setDirection();
					}
					else if(my < py)	{
						sprite->setAttacking(true);
						sprite->setDirection();
					}
					else if(my > py)	{
						sprite->setAttacking(true);
						sprite->setDirection();
					}
					ts = ccTimer::getMilliseconds();
				}
			}
		}
		
		if(sprite->isAttacking())	{
			if(ts + 320 < ccTimer::getMilliseconds())	{
				player->beAttacked(1);
				ts = ccTimer::getMilliseconds();
			}
		}
		
		sprite->setPos(sprite->getRealXPos() - camera->getXPos(), sprite->getRealYPos() - camera->getYPos(), 5);
	}
}
