/*	dcrpggame.h
	DCRPG class.
	Copyright (C) 2004 Lawrence Sebald	*/
	
/*	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef DCRPGGAME_H
#define DCRPGGAME_H

#include <ccvideo.h>
#include <ccmap.h>
#include <ccfont.h>
#include <ccsprite.h>
#include <ccvertex.h>
#include <cctexture.h>
#include <cccontroller.h>
#include "dcrpgsprite.h"
#include "dcrpgcamera.h"
#include "dcrpgplayer.h"
#include <vector>

using namespace crabclaw;

namespace dcrpg	{
	class DCRPG	{
		private:
			ccController *cont;
			ccScreen *scr;
			ccTTFFont *font;
			bool online;

			ccLJMMap *curmap;
			ccSprite *buttons;
			DCRPGPlayer *player;
			DCRPGCamera *camera;
			std::vector<DCRPGEnemy *> enemies;

			uint64 timer;

			void mainLoop();

		public:
			DCRPG(ccScreen *s, ccController *c, ccTTFFont *f) { scr = s; cont = c; font = f; online = false; }
			~DCRPG() { delete scr; delete cont; delete font; delete player; delete curmap; delete buttons; }

			ccScreen *getScreen() { return scr; }
			ccController *getController() { return cont; }
			ccTTFFont *getFont() { return font; }

			void setMap(ccLJMMap *map)	{ curmap = map; }
			void setPlayer(DCRPGPlayer *p)	{ player = p; }
			void addEnemy(DCRPGEnemy *e)	{ enemies.push_back(e); }

			ccLJMMap *getMap()	{ return curmap; }
			DCRPGSprite *getSprite() { return player->getSprite(); }
			DCRPGPlayer *getPlayer() { return player; }
			DCRPGCamera *getCamera() { return camera; }

			bool isOnline() { return online; }

			void newGame();

			DCRPGEnemy *getEnemyAt(int x, int y, int d);
	};
}

#endif
