#ifndef DCRPGPLAYER_H
#define DCRPGPLAYER_H

#include "dcrpgsprite.h"
#include <ccdrawable.h>
#include <cctimer.h>
#include <ccfont.h>

namespace dcrpg	{
	class DCRPG;
	
	class DCRPGPlayer : public crabclaw::ccDrawable	{
		private:
			DCRPGSprite *sprite;
			crabclaw::ccTTFFont *font;
			int hp;
			uint64 att_timer;
			
		public:
			DCRPGPlayer(int h, DCRPGSprite *s, crabclaw::ccTTFFont *f)	{ hp = h; sprite = s; font = f;}
			~DCRPGPlayer()	{ delete sprite; }
			
			int getList()	{ return ccScreen::LIST_TRANSLUCENT; }
			void draw(ccScreen *scr)	{
				if(hp > 0)	{
					sprite->draw(scr);
					font->printf(scr, 32, 64, 32.0f, 0xFFFFFFFF, "HP: %d", hp);
				}
			}
			
			void beAttacked(int dmg)	{
				if(hp > 0)
					hp -= dmg;
			}
			
			DCRPGSprite *getSprite() { return sprite; }
			
			uint64 getTimer() { return att_timer; }
			void updateTimer() { att_timer = crabclaw::ccTimer::getMilliseconds(); }
			
			int getHP()	{ return hp; }
	};
	
	class DCRPGEnemy : public crabclaw::ccDrawable	{
		private:
			DCRPGSprite *sprite;
			DCRPG *game;
			crabclaw::ccTTFFont *font;
			int hp;
			uint64 ts;
			
		public:
			DCRPGEnemy(int h, DCRPGSprite *s, crabclaw::ccTTFFont *f, DCRPG *d)	{ hp = h; sprite = s; font = f; game = d; }
			DCRPGEnemy() { };
			~DCRPGEnemy()	{	delete sprite; }
			
			int getList()	{ return ccScreen::LIST_TRANSLUCENT; }
			void draw(ccScreen *scr)	{
				if(hp > 0)	{
					sprite->draw(scr);
					move();
					sprite->incrementAnim();
				}
			}
			
			void beAttacked(int dmg)	{
				if(hp > 0)
					hp -= dmg;
			}
			
			DCRPGSprite *getSprite()	{ return sprite; }
			int getHP()	{ return hp; }
			
			void move();	
	};
}


#endif
