
#ifndef DCRPGSPRITE_H
#define DCRPGSPRITE_H
#include <ccsprite.h>
#include <cctexture.h>

using crabclaw::ccSprite;
using crabclaw::ccSpriteAnim;
using crabclaw::ccTexture;
using crabclaw::ccScreen;

namespace dcrpg	{
	class DCRPGSprite : public ccSprite	{
		private:
			int direction;
			int state;
			bool attacking;
			bool running;
			
			ccSpriteAnim *left;
			ccSpriteAnim *right;
			ccSpriteAnim *up;
			ccSpriteAnim *down;
			ccSpriteAnim *runleft;
			ccSpriteAnim *runright;
			ccSpriteAnim *runup;
			ccSpriteAnim *rundown; 
			ccSpriteAnim *attackdown;
			ccSpriteAnim *attackup;
			ccSpriteAnim *attackleft;
			ccSpriteAnim *attackright;
			int mxpos;
			int mypos;
			
		public:
			static const int FACING_LEFT = 0;
			static const int FACING_RIGHT = 1;
			static const int FACING_UP = 2;
			static const int FACING_DOWN = 3;

			static const int STATE_STANDING = 0;
			static const int STATE_WALKING = 1;
			
			DCRPGSprite(ccTexture *texture, float u, float v, uint8 list);
			~DCRPGSprite();
			
			void setDirection(int d = 4);
			void setState(int s);
			void setRunning(bool r);
			void setAttacking(bool r);
			
			void setAnims(ccSpriteAnim *l, ccSpriteAnim *r, ccSpriteAnim *u, ccSpriteAnim *d,
			              ccSpriteAnim *rl, ccSpriteAnim *rr, ccSpriteAnim *ru, ccSpriteAnim *rd,
			              ccSpriteAnim *al, ccSpriteAnim *ar, ccSpriteAnim *au, ccSpriteAnim *ad);
			              
			int getDirection();
			int getState();
			bool isRunning();
			bool isAttacking();
			
			int getRealXPos() { return mxpos; }
			int getRealYPos() { return mypos; }
			
			void setRealXPos(int x) { mxpos = x; }
			void setRealYPos(int y) { mypos = y; }
			
			void setRealPos(int x, int y)	{ mxpos = x; mypos = y; }
			
			void draw(ccScreen *scr);
	};
}

#endif
